import{s as ge,n as _e,o as xe}from"../chunks/scheduler.6062bdaf.js";import{S as ze,i as ve,g as m,s as i,r as h,A as Oe,h as p,f as o,c as r,j as g,u as _,x as H,k as x,y as t,a as z,v,d as O,t as $,w as b}from"../chunks/index.4bca734e.js";import{D as q}from"../chunks/Docstring.ed07512f.js";import{H as he}from"../chunks/Heading.723dceba.js";function $e(pe){let d,j,V,A,T,S,y,F,n,P,Y,D,se="Handles the ONNX Runtime optimization process for models shared on huggingface.co/models.",Z,N,R,ee,l,L,te,U,de="Computes the dictionary mapping the name of the fused operators to their number of apparition in the model.",ne,c,C,oe,E,le="Compute the difference in the number of nodes between the original and the optimized model.",ie,u,k,re,M,ce=`Compute the dictionary mapping the operators name to the difference in the number of corresponding nodes between
the original and the optimized model.`,ae,f,w,me,I,ue="Optimizes a model given the optimization specifications defined in <code>optimization_config</code>.",W,X,G;return T=new he({props:{title:"Optimization",local:"optimization",headingTag:"h1"}}),y=new he({props:{title:"ORTOptimizer",local:"optimum.onnxruntime.ORTOptimizer",headingTag:"h2"}}),P=new q({props:{name:"class optimum.onnxruntime.ORTOptimizer",anchor:"optimum.onnxruntime.ORTOptimizer",parameters:[{name:"onnx_model_path",val:": typing.List[os.PathLike]"},{name:"config",val:": PretrainedConfig"},{name:"from_ortmodel",val:": bool = False"}],source:"https://github.com/huggingface/optimum/blob/v1.19.0/optimum/onnxruntime/optimization.py#L45"}}),R=new q({props:{name:"from_pretrained",anchor:"optimum.onnxruntime.ORTOptimizer.from_pretrained",parameters:[{name:"model_or_path",val:": typing.Union[str, os.PathLike, optimum.onnxruntime.modeling_ort.ORTModel]"},{name:"file_names",val:": typing.Optional[typing.List[str]] = None"}],parametersDescription:[{anchor:"optimum.onnxruntime.ORTOptimizer.from_pretrained.model_or_path",description:`<strong>model_or_path</strong> (<code>Union[str, os.PathLike, ORTModel]</code>) &#x2014;
The path to a local directory hosting the model to optimize or an instance of an <code>ORTModel</code> to quantize.
Can be either:<ul>
<li>A path to a local <em>directory</em> containing the model to optimize.</li>
<li>An instance of <a href="/docs/optimum/v1.19.0/en/onnxruntime/package_reference/modeling_ort#optimum.onnxruntime.ORTModel">ORTModel</a>.</li>
</ul>`,name:"model_or_path"},{anchor:"optimum.onnxruntime.ORTOptimizer.from_pretrained.file_names(Optional[List[str]],",description:`<strong>file_names(<code>Optional[List[str]]</code>,</strong> defaults to <code>None</code>) &#x2014;
The list of file names of the models to optimize.`,name:"file_names(Optional[List[str]],"}],source:"https://github.com/huggingface/optimum/blob/v1.19.0/optimum/onnxruntime/optimization.py#L74"}}),L=new q({props:{name:"get_fused_operators",anchor:"optimum.onnxruntime.ORTOptimizer.get_fused_operators",parameters:[{name:"onnx_model_path",val:": typing.Union[str, os.PathLike]"}],parametersDescription:[{anchor:"optimum.onnxruntime.ORTOptimizer.get_fused_operators.onnx_model_path",description:`<strong>onnx_model_path</strong> (<code>Union[str, os.PathLike]</code>) &#x2014;
Path of the ONNX model.`,name:"onnx_model_path"}],source:"https://github.com/huggingface/optimum/blob/v1.19.0/optimum/onnxruntime/optimization.py#L248",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The dictionary mapping the name of the fused operators to their number of apparition in the model.</p>
`}}),C=new q({props:{name:"get_nodes_number_difference",anchor:"optimum.onnxruntime.ORTOptimizer.get_nodes_number_difference",parameters:[{name:"onnx_model_path",val:": typing.Union[str, os.PathLike]"},{name:"onnx_optimized_model_path",val:": typing.Union[str, os.PathLike]"}],parametersDescription:[{anchor:"optimum.onnxruntime.ORTOptimizer.get_nodes_number_difference.onnx_model_path",description:`<strong>onnx_model_path</strong> (<code>Union[str, os.PathLike]</code>) &#x2014;
Path of the ONNX model.`,name:"onnx_model_path"},{anchor:"optimum.onnxruntime.ORTOptimizer.get_nodes_number_difference.onnx_optimized_model_path",description:`<strong>onnx_optimized_model_path</strong> (<code>Union[str, os.PathLike]</code>) &#x2014;
Path of the optimized ONNX model.`,name:"onnx_optimized_model_path"}],source:"https://github.com/huggingface/optimum/blob/v1.19.0/optimum/onnxruntime/optimization.py#L267",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The difference in the number of nodes between the original and the optimized model.</p>
`}}),k=new q({props:{name:"get_operators_difference",anchor:"optimum.onnxruntime.ORTOptimizer.get_operators_difference",parameters:[{name:"onnx_model_path",val:": typing.Union[str, os.PathLike]"},{name:"onnx_optimized_model_path",val:": typing.Union[str, os.PathLike]"}],parametersDescription:[{anchor:"optimum.onnxruntime.ORTOptimizer.get_operators_difference.onnx_model_path",description:`<strong>onnx_model_path</strong> (<code>Union[str, os.PathLike]</code>) &#x2014;
Path of the ONNX model.`,name:"onnx_model_path"},{anchor:"optimum.onnxruntime.ORTOptimizer.get_operators_difference.onnx_optimized_model_path",description:`<strong>onnx_optimized_model_path</strong> (<code>Union[str, os.PathLike]</code>) &#x2014;
Path of the optimized ONNX model.`,name:"onnx_optimized_model_path"}],source:"https://github.com/huggingface/optimum/blob/v1.19.0/optimum/onnxruntime/optimization.py#L296",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The dictionary mapping the operators name to the difference in the number of corresponding nodes between the
original and the optimized model.</p>
`}}),w=new q({props:{name:"optimize",anchor:"optimum.onnxruntime.ORTOptimizer.optimize",parameters:[{name:"optimization_config",val:": OptimizationConfig"},{name:"save_dir",val:": typing.Union[str, os.PathLike]"},{name:"file_suffix",val:": typing.Optional[str] = 'optimized'"},{name:"use_external_data_format",val:": typing.Optional[bool] = None"},{name:"one_external_file",val:": bool = True"}],parametersDescription:[{anchor:"optimum.onnxruntime.ORTOptimizer.optimize.optimization_config",description:`<strong>optimization_config</strong> (<a href="/docs/optimum/v1.19.0/en/onnxruntime/package_reference/configuration#optimum.onnxruntime.OptimizationConfig">OptimizationConfig</a>) &#x2014;
The configuration containing the parameters related to optimization.`,name:"optimization_config"},{anchor:"optimum.onnxruntime.ORTOptimizer.optimize.save_dir",description:`<strong>save_dir</strong> (<code>Union[str, os.PathLike]</code>) &#x2014;
The path used to save the optimized model.`,name:"save_dir"},{anchor:"optimum.onnxruntime.ORTOptimizer.optimize.file_suffix",description:`<strong>file_suffix</strong> (<code>str</code>, defaults to <code>&quot;optimized&quot;</code>) &#x2014;
The file suffix used to save the optimized model.`,name:"file_suffix"},{anchor:"optimum.onnxruntime.ORTOptimizer.optimize.use_external_data_format",description:`<strong>use_external_data_format</strong> (<code>Optional[bool]</code>, defaults to <code>None</code>) &#x2014;
Whether to use external data format to store model of size &gt;= 2Gb. This argument is deprecated.`,name:"use_external_data_format"},{anchor:"optimum.onnxruntime.ORTOptimizer.optimize.one_external_file",description:`<strong>one_external_file</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
When <code>use_external_data_format=True</code>, whether to save all tensors to one external file.
If False, save each tensor to a file named with the tensor name.`,name:"one_external_file"}],source:"https://github.com/huggingface/optimum/blob/v1.19.0/optimum/onnxruntime/optimization.py#L121"}}),{c(){d=m("meta"),j=i(),V=m("p"),A=i(),h(T.$$.fragment),S=i(),h(y.$$.fragment),F=i(),n=m("div"),h(P.$$.fragment),Y=i(),D=m("p"),D.textContent=se,Z=i(),N=m("div"),h(R.$$.fragment),ee=i(),l=m("div"),h(L.$$.fragment),te=i(),U=m("p"),U.textContent=de,ne=i(),c=m("div"),h(C.$$.fragment),oe=i(),E=m("p"),E.textContent=le,ie=i(),u=m("div"),h(k.$$.fragment),re=i(),M=m("p"),M.textContent=ce,ae=i(),f=m("div"),h(w.$$.fragment),me=i(),I=m("p"),I.innerHTML=ue,W=i(),X=m("p"),this.h()},l(e){const s=Oe("svelte-u9bgzb",document.head);d=p(s,"META",{name:!0,content:!0}),s.forEach(o),j=r(e),V=p(e,"P",{}),g(V).forEach(o),A=r(e),_(T.$$.fragment,e),S=r(e),_(y.$$.fragment,e),F=r(e),n=p(e,"DIV",{class:!0});var a=g(n);_(P.$$.fragment,a),Y=r(a),D=p(a,"P",{"data-svelte-h":!0}),H(D)!=="svelte-grwr9f"&&(D.textContent=se),Z=r(a),N=p(a,"DIV",{class:!0});var fe=g(N);_(R.$$.fragment,fe),fe.forEach(o),ee=r(a),l=p(a,"DIV",{class:!0});var B=g(l);_(L.$$.fragment,B),te=r(B),U=p(B,"P",{"data-svelte-h":!0}),H(U)!=="svelte-yjxy0i"&&(U.textContent=de),B.forEach(o),ne=r(a),c=p(a,"DIV",{class:!0});var J=g(c);_(C.$$.fragment,J),oe=r(J),E=p(J,"P",{"data-svelte-h":!0}),H(E)!=="svelte-nuojg2"&&(E.textContent=le),J.forEach(o),ie=r(a),u=p(a,"DIV",{class:!0});var K=g(u);_(k.$$.fragment,K),re=r(K),M=p(K,"P",{"data-svelte-h":!0}),H(M)!=="svelte-1qznsek"&&(M.textContent=ce),K.forEach(o),ae=r(a),f=p(a,"DIV",{class:!0});var Q=g(f);_(w.$$.fragment,Q),me=r(Q),I=p(Q,"P",{"data-svelte-h":!0}),H(I)!=="svelte-akjqps"&&(I.innerHTML=ue),Q.forEach(o),a.forEach(o),W=r(e),X=p(e,"P",{}),g(X).forEach(o),this.h()},h(){x(d,"name","hf:doc:metadata"),x(d,"content",be),x(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(l,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(c,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(u,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(f,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(n,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,s){t(document.head,d),z(e,j,s),z(e,V,s),z(e,A,s),v(T,e,s),z(e,S,s),v(y,e,s),z(e,F,s),z(e,n,s),v(P,n,null),t(n,Y),t(n,D),t(n,Z),t(n,N),v(R,N,null),t(n,ee),t(n,l),v(L,l,null),t(l,te),t(l,U),t(n,ne),t(n,c),v(C,c,null),t(c,oe),t(c,E),t(n,ie),t(n,u),v(k,u,null),t(u,re),t(u,M),t(n,ae),t(n,f),v(w,f,null),t(f,me),t(f,I),z(e,W,s),z(e,X,s),G=!0},p:_e,i(e){G||(O(T.$$.fragment,e),O(y.$$.fragment,e),O(P.$$.fragment,e),O(R.$$.fragment,e),O(L.$$.fragment,e),O(C.$$.fragment,e),O(k.$$.fragment,e),O(w.$$.fragment,e),G=!0)},o(e){$(T.$$.fragment,e),$(y.$$.fragment,e),$(P.$$.fragment,e),$(R.$$.fragment,e),$(L.$$.fragment,e),$(C.$$.fragment,e),$(k.$$.fragment,e),$(w.$$.fragment,e),G=!1},d(e){e&&(o(j),o(V),o(A),o(S),o(F),o(n),o(W),o(X)),o(d),b(T,e),b(y,e),b(P),b(R),b(L),b(C),b(k),b(w)}}}const be='{"title":"Optimization","local":"optimization","sections":[{"title":"ORTOptimizer","local":"optimum.onnxruntime.ORTOptimizer","sections":[],"depth":2}],"depth":1}';function Te(pe){return xe(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ce extends ze{constructor(d){super(),ve(this,d,Te,$e,ge,{})}}export{Ce as component};
